format PE GUI 4.0

include '%fasminc%/win32a.inc'

null	equ	ebx
false	equ	ebx
_0	equ	ebx

macro strtbl name,[string]
{
  common
    label name dword
  forward
    local label
    dd label
  common
    dd NULL
  forward
    label db string,0
}

macro enum [names]
{
 _enum_count = 0
 forward
   names = _enum_count
   _enum_count = _enum_count+1
}

enum operation_enclose,operation_parenthesis,operation_mul,operation_div,operation_add,operation_sub,\
	operation_sin,operation_cos,operation_tan,operation_sqrt,operation_abs

start:
	xor	ebx,ebx
	invoke	InitCommonControls
	;
	invoke	GetModuleHandle,null
	invoke	DialogBoxParam,eax,ID_DLGMAIN,null,DlgProc,null
	invoke	ExitProcess,_0

proc DlgProc,.hDlg,.uMsg,.wParam,.lParam
 local .szExpression[1024]:BYTE
	push	ebx esi edi
	xor	ebx,ebx
	mov	eax,[.uMsg]
	mov	esi,[.hDlg]
	cmp	eax,WM_COMMAND
	je	.wmcommand
	cmp	eax,WM_CLOSE
	je	.wmclose
	cmp	eax,WM_INITDIALOG
	je	.wminitdialog
 .default:
	xor	eax,eax
	jmp	.return
 .wmcommand:
	movzx	edx,word[.wParam+2]
	cmp	edx,CBN_EDITCHANGE
	je	.edit_changed
	movzx	eax,word[.wParam]
	cmp	eax,IDM_EXIT
	je	.wmclose
	cmp	eax,IDCANCEL
	je	.wmclose
	cmp	eax,IDOK
	jne	.default
 .idok:
	lea	edi,[.szExpression]
	invoke	GetDlgItemText,esi,ID_DOUBLE,edi,1024
	invoke	SetDlgItemText,esi,ID_EXPRESSION,edi
	jmp	.default
 .edit_changed:
	lea	eax,[.szExpression]
	push	eax
	invoke	SendDlgItemMessage,esi,ID_EXPRESSION,WM_GETTEXT,1024,eax
	stdcall count_expression	; address of string already on stack
	cmp	[operations_count],_0
	jne	.error
	cmp	[numbers_count],1
	jne	.error
	cmp	[global_error],bl
	jne	.error

	lea	edi,[.szExpression]	; print float number here
	call	print_float
	invoke	SetDlgItemText,esi,ID_DOUBLE,edi

	call	print_hex
	invoke	SetDlgItemText,esi,ID_HEX,edi
	jmp	.default
  .error:
	invoke	SetDlgItemText,esi,ID_DOUBLE,szError
	invoke	SetDlgItemText,esi,ID_HEX,szError
	jmp	.default
 .wmclose:
	invoke	EndDialog,esi,_0
	jmp	.default
 .wminitdialog:
	invoke	SendDlgItemMessage,[.hDlg],ID_EXPRESSION,CB_LIMITTEXT,1024,_0
 .processed:
	xor	eax,eax
	inc	eax
 .return:
	pop	edi esi ebx
	ret
endp

unary_minus_mask = 1
number_read	 = 2

proc count_expression,.pszExpression
 local .flags:BYTE,\
       .CR:WORD
	push	esi edi
	; init fpu
	finit
	; set round mode to minus infinity
	fstcw	[.CR]
	and	[.CR],not 110000000000b
	or	[.CR],010000000000b
	fldcw	[.CR]
	;
	mov	[global_error],bl
	mov	[operations_count],_0
	mov	[numbers_count],_0
	mov	esi,[.pszExpression]
	mov	[.flags],unary_minus_mask
 .main_loop:
	mov	al,[esi]
	test	al,al
	je	.done
	cld
	mov	ecx,operations_size
	mov	edi,operations
  repne scasb
	je	.found_operation

	mov	edi,functions
 .cmpstrs:
	mov	ecx,[edi]
	test	ecx,ecx
	je	.not_operation
	push	esi
	dec	ecx
     @@:
	lea	eax,[esi-1]
	inc	ecx
	cmp	[ecx],bl
	je	@f
	lodsb
	cmp	al,[ecx]
	je	@b
     @@:
	pop	esi
	je	.found
	add	edi,4
	jmp	.cmpstrs
 .found:
	mov	esi,eax
	sub	edi,functions
	shr	edi,2
	add	edi,operation_sin
	jmp	.found_func

 .found_operation:			; found operation sign
	sub	edi,operations+1
 .found_func:
	cmp	edi,operation_parenthesis
	jne	@f
	or	[.flags],unary_minus_mask
     @@:
	cmp	edi,operation_enclose
;        jne     .not_int3
;        int3
; .not_int3:
	je	.ok
	cmp	edi,operation_parenthesis
	jbe	@f
	and	[.flags],not number_read
	jmp	.ok
     @@:
	test	[.flags],number_read
	je	.ok
	mov	[global_error],1
 .ok:
	cmp	edi,operation_sub	; test for unary_minus
	jne	@f
	test	[.flags],unary_minus_mask
	je	@f
	fldz
	mov	eax,[numbers_count]
	lea	eax,[eax*5]
	fstp	[numbers_stack+eax*2]
	inc	[numbers_count]
     @@:
	inc	esi
	mov	al,[priorities+edi]
	call	pop_operations
	test	edi,edi 		; if operation is enclosing parentesis
	je	.main_loop
	mov	edx,[operations_count]
	mov	dword[operations_stack+edx],edi
	inc	[operations_count]
	jmp	.main_loop
 .not_operation:		; recognize number here
	test	[.flags],number_read
	je	@f
	mov	[global_error],1
     @@:
	call	read_number
	jc	.not_number
 .number_ok:
	or	[.flags],number_read
	mov	eax,[numbers_count]
	lea	eax,[eax*5]
	fstp	[numbers_stack+eax*2]
	inc	[numbers_count]
	and	[.flags],not unary_minus_mask
	jmp	.main_loop
 .not_number:
 .done:
	mov	al,0feh
	call	pop_operations
	pop	edi esi
	xor	eax,eax
	ret
endp

pop_operations:
	push	esi edi
	mov	ecx,[operations_count]
	test	ecx,ecx
	je	.ret
 .pop_loop:
	movzx	edx,[operations_stack+ecx-1]
	mov	ah,[priorities+edx]
	cmp	al,ah
	jb	.ret
	; make operation on numbers in stack
	mov	edi,[numbers_count]
	test	edi,edi
	je	.ret
	dec	edi	; get index of last array element
	dec	edx
	je	@f
	cmp	edx,operation_sin-1
	jnb	@f
	test	edi,edi
	je	.ret
     @@:
	push	eax
	lea	edi,[edi*5]
	shl	edi,1
	fld	[numbers_stack+edi]
	jmp	dword[edx*4+@f]
     @@:dd	.parentesis,.mul,.div,.add,.sub,.sin,.cos,.tan,.sqrt,.abs
  .sin:
	fsin
	call	check_for_errors
	jmp	.func_complete
  .cos:
	fcos
	call	check_for_errors
	jmp	.func_complete
  .tan:
	fptan
	fistp	[temp]
	call	check_for_errors
	jmp	.func_complete
  .sqrt:
	fsqrt
	call	check_for_errors
	jmp	.func_complete
  .abs:
	fabs
	jmp	.func_complete
  .func_complete:
	call	test_number_range
	fstp	[numbers_stack+edi]
	pop	eax
	jmp	.operation_delete
  .parentesis:
	pop	eax
	mov	edx,ecx
	mov	ecx,1
	fistp	[temp]
	cmp	al,0xff
	jne	.operation_cancel
	mov	ecx,edx
	dec	al
	jmp	.operation_delete
  .mul:
	fld	[numbers_stack+edi-10]
	fmulp
	call	check_for_errors
	jmp	.operation_complete
  .div:
	fld	[numbers_stack+edi-10]
	fxch
	fdivp
	call	check_for_errors
	jmp	.operation_complete
  .add:
	fld	[numbers_stack+edi-10]
	faddp
	call	check_for_errors
	jmp	.operation_complete
  .sub:
	fld	[numbers_stack+edi-10]
	fxch
	fsubp
	call	check_for_errors
;        jmp     .operation_complete

  .operation_complete:
	call	test_number_range
	fstp	[numbers_stack+edi-10]
	dec	[numbers_count]
	pop	eax
  .operation_delete:
	dec	[operations_count]
  .operation_cancel:
	dec	ecx
	jne	.pop_loop
 .ret:
	pop	edi esi
	ret

; translates float into qword and then into hex string
proc print_hex
 local .CR:WORD
	push	ecx edx edi
	; set round mode to nearest
	fstcw	[.CR]
	and	[.CR],not 110000000000b
	fldcw	[.CR]

	fld	[numbers_stack] ; load number from stack
	fld	[.max]
	fcomp
	fstsw	ax
	fistp	[.int_part]

	mov	dword[edi],"unav"
	mov	dword[edi+4],"aila"
	mov	dword[edi+8],"ble"

	sahf
	jbe	.ret

	cld
	mov	word[edi],"0x"
	inc	edi
	inc	edi
	mov	ecx,8
 .to_hex:
	mov	al,byte[.int_part-1+ecx]
	mov	ah,al
	shr	al,4
	add	al,'0'
	cmp	al,'9'+1
	jb	@f
	add	al,'a'-'9'-1
     @@:
	stosb
	mov	al,ah
	and	al,0xf
	add	al,'0'
	cmp	al,'9'+1
	jb	@f
	add	al,'a'-'9'-1
     @@:
	stosb
	loop	.to_hex
	mov	al,0
	stosb
 .ret:
	pop	edi edx ecx
	ret
 .max		dq 9223372036854774800f
 .int_part	dq ?
endp

; translates float into string, esi = pointer to output string
print_float:
	push	ecx edx edi
	cld
	xor	ecx,ecx
	xor	edx,edx
	fld	[numbers_stack] ; load number from stack
	ftst
	fstsw	ax
	sahf
	je	.normalized
	ja	@f
	inc	dl
	fchs
     @@:
 .normalize:
	fld	[.1]
	fcomp
	fstsw	ax
	sahf
	ja	.neg_exp
	fld	[.10]
	fcomp
	fstsw	ax
	sahf
	jnb	.normalized
	; positive exp
	fld	[read_number.10]
	fdivp
	inc	ecx
	jmp	.normalize
 .neg_exp:
	fld	[read_number.10]
	fmulp
	dec	ecx
	jmp	.normalize
 .normalized:
	test	dl,dl
	je	@f
	mov	byte[edi],'-'
	inc	edi
	dec	dl
     @@:
	mov	edx,ecx
	xor	ecx,ecx
	cmp	edx,10
	jg	.print_exp
	cmp	edx,-10
	jl	.print_exp
	xchg	ecx,edx
	cmp	ecx,_0
	jl	.print_negative
 .print_exp:
	fld	[.1e_10]
	fadd	st1,st0
	fadd	st0,st0
	fxch
 .print_positive:
	fist	[temp]
	fild	[temp]
	fsubp
	fld	[read_number.10]
	fmul	st1,st0
	fmulp	st2,st0
	mov	eax,[temp]
	add	al,'0'
	stosb
	cmp	ecx,_0
	jg	@f
	fcom
	fstsw	ax
	sahf
	jbe	.done_positive
	test	ecx,ecx
	jne	@f
	mov	al,'.'
	stosb
     @@:
	dec	ecx
	jmp	.print_positive
 .done_positive:
	fistp	[temp]
	fistp	[temp]

	cmp	edx,_0
	je	.ret
	mov	al,'e'
	stosb
	mov	al,'+'
	jns	@f
	mov	al,'-'
	neg	edx
     @@:
	stosb
	mov	eax,edx
	call	print_int
	jmp	.ret
 .print_negative:
	neg	ecx
	mov	word[edi],"0."
	inc	edi
	inc	edi
	dec	ecx
	jecxz	.zeroes_done
	mov	al,'0'
    rep stosb
 .zeroes_done:
	fld	[.1e_10]
	fadd	st1,st0
	fadd	st0,st0
	fxch
 .negative_loop:
	fist	[temp]
	fild	[temp]
	fsubp
	fld	[read_number.10]
	fmul	st1,st0
	fmulp	st2,st0
	mov	eax,[temp]
	add	al,'0'
	stosb
	fcom
	fstsw	ax
	sahf
	ja	.negative_loop
	fistp	[temp]
	fistp	[temp]
	jmp	.ret
 .ret:
	mov	[edi],bl
	pop	edi edx ecx
	ret
.1e_10	dq	1e-10
.1	dq	0.99999999989999999
.10	dq	9.9999999999

print_int:
	push	eax edx
	xor	edx,edx
	div	[.10]
	test	eax,eax
	je	@f
	call	print_int
     @@:
	lea	eax,[edx+'0']
	stosb
	pop	edx eax
	ret
.10	dd	10

; reads number from string
read_number:
	push	ecx edx
	fldz
	xor	eax,eax 	; read int part
	xor	edx,edx
	inc	dh
	cmp	byte[esi],'-'
	jne	@f
	or	dl,1
	inc	esi
     @@:
	cmp	word[esi],"pi"
	je	.pi
	cmp	word[esi],"PI"
	jne	.not_pi
 .pi:
	fldpi
	xor	edx,edx
	add	esi,3
	jmp	.done
 .not_pi:
	cmp	word[esi],"0x"	; test for hex number
	jne	.read_float
	inc	esi
	inc	esi
	mov	ah,15
	xor	ecx,ecx
	xor	edx,edx
	push	edx
 .read_hex:
	lodsb
	sub	al,'0'
	jb	.hex_read
	cmp	al,9+1
	jb	@f
	or	al,20h
	sub	al,'a'-'9'-1
	cmp	al,0fh
	ja	.hex_read
     @@:
	shld	ecx,edx,4
	shl	edx,4
	or	dl,al
	dec	ah
	jne	.read_hex
 .hex_read:
	mov	dword[.hex],edx
	mov	dword[.hex+4],ecx
	fild	[.hex]
	pop	edx
	mov	dh,0
	cmp	ah,15
	jne	@f
	inc	dh
     @@:
	jmp	.done
 .read_float:
	lodsb
	sub	al,'0'
	cmp	al,10
	jnb	@f
	xor	dh,dh
	fld	[.10]
	fmulp
	mov	[temp],eax
	fild	[temp]
	faddp
	jmp	.read_float
     @@:
	cmp	al,'.'-'0'
	jne	.test_exp
	fld1
     @@:			; read frac part
	lodsb
	sub	al,'0'
	cmp	al,10
	jnb	@f
	mov	[temp],eax
	fld	[.10]
	fdivp
	call	check_for_errors
	fild	[temp]
	fmul	st0,st1
	call	check_for_errors
	faddp	st2,st0
	call	check_for_errors
	jmp	@b
     @@:
	fistp	[temp]
 .test_exp:
	cmp	al,'e'-'0'
	je	.exp
	cmp	al,'E'-'0'
	jne	.done
 .exp:
	xor	eax,eax
	xor	ecx,ecx
	inc	dh
	cmp	byte[esi],'+'
	je	.inc_esi
	cmp	byte[esi],'-'
	jne	@f
	or	dl,2
 .inc_esi:
	inc	esi
     @@:
	lodsb
	sub	al,'0'
	cmp	al,10
	jnb	@f
	xor	dh,dh
	imul	ecx,10
	add	ecx,eax
	jmp	@b
     @@:
	jecxz	.done
	cmp	ecx,5500
	jl	@f
	mov	ecx,5500
	mov	[global_error],1
     @@:
	fld	[.10]
	fxch
 .apply_exp:
	test	dl,2
	je	.mul
	fdiv	st0,st1
	ftst
	fstsw	ax
	sahf
	je	.end_loop
	jmp	.loop_exp
   .mul:
	fmul	st0,st1
 .loop_exp:
	call	check_for_errors
	loop	.apply_exp
 .end_loop:
	fxch
	fistp	[temp]
 .done:
	call	test_number_range

	test	dl,1
	je	@f
	fchs
     @@:
	clc
	or	dh,dh
	je	@f
	stc
     @@:
	dec esi
 .ret:
	pop	edx ecx
	ret
 .10		dt	10.0
 .hex		dq	?

test_number_range:
	push	eax
	fld	st0
	fabs
	fld	[.max]	; test number is in range
	fcompp
	fstsw	ax
	sahf
	jae	@f
	mov	[global_error],1
     @@:

;        fld     [.min]  ; test number is in range
;        fcompp
;        fstsw   ax
;        sahf
;        jbe     @f
;        mov     [global_error],1
;     @@:
	pop	eax
	ret
 .max	dt 1e+4931
 .min	dt 1e-4931

check_for_errors:
	push	eax
	fxam
	fstsw	ax
	and	ah,01000101b
	cmp	ah,00000100b
	je	.ret
	cmp	ah,01000000b
	je	.ret
	mov	[global_error],1
 .ret:
	pop	eax
	ret

global_error	db ?

szError 	db 0

operations	db ')','(','*','/','+','-'
operations_size = $-operations
strtbl		functions, "sin","cos","tan","sqrt","abs"
priorities	db	0ffh,0,2,2,3,3,5,5,5,5,5

include 'resource.inc'
include 'import.inc'

temp			dd	?

operations_count	dd ?
operations_stack	rb 1024
numbers_count		dd ?
numbers_stack		rt 1024
